// pbmuse.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "resource.h"
#include <lmcons.h>
#include <stdio.h>


char inipath[_MAX_PATH] = "\x0"; //   power builder-
char inifile[_MAX_PATH] = "\x0"; //   power builder-
char userinipath[_MAX_PATH] = "\x0"; //   power builder-
char username[UNLEN + 1] = "\x0";	//   

// Global Variables:
HINSTANCE hInst;								// current instance

// Foward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
	MSG msg;

	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}

	return msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage is only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= 0;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= NULL;
	wcex.hCursor		= NULL;
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= (LPCSTR)IDC_PBMUSE;
	wcex.lpszClassName	= "STATIC";
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
//constants
LPCSTR		PBINI = "pb.ini";
LPCSTR		SETTINGS = "inifiles";
LPCSTR		LPSZBPREGKEY  = "CLSID\\{9537EB51-52CC-11D0-9945-080009AC61A9}\\InProcServer32";


BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // Store instance handle in our global variable

   hWnd = CreateWindow("STATIC", "", WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

	DWORD dwSize = UNLEN;
	//    
	if(!GetUserName(username, &dwSize)) return FALSE;

	//    pb.ini
	HKEY hKey;

	if(RegOpenKeyEx(HKEY_CLASSES_ROOT, LPSZBPREGKEY, 0,
			KEY_READ, &hKey) != ERROR_SUCCESS) return -1;

	DWORD dwType = 0;
	dwSize = _MAX_PATH;

	if(RegQueryValueExA(hKey, "", NULL, 
			&dwType, (LPBYTE) inipath, &dwSize) != ERROR_SUCCESS) return -1;
	RegCloseKey(hKey);

	strcpy(&inipath[strlen(inipath) - 9], "");

	sprintf(userinipath, "%s\\%s\\%s\\%s", inipath, SETTINGS, username, PBINI);

	sprintf(inifile, "%s\\%s", inipath, PBINI);

	DWORD dwResult = GetFileAttributes(userinipath);
	if(dwResult != 0xffffffff) {
		CopyFile(userinipath, inifile, FALSE);
	}
/*
			sprintf(userinipath, "%s\\%s", inipath, SETTINGS);
			if(GetFileAttributes(userinipath) != FILE_ATTRIBUTE_DIRECTORY)
				if(!CreateDirectory(userinipath, NULL)) return -1;

			sprintf(userinipath, "%s\\%s\\%s", inipath, SETTINGS, username);

			if(GetFileAttributes(userinipath) != FILE_ATTRIBUTE_DIRECTORY)
				if(!CreateDirectory(userinipath, NULL)) return -1;

			sprintf(userinipath, "%s\\%s\\%s\\%s", inipath, SETTINGS, username, PBINI);
			CopyFile(inifile, userinipath, FALSE);
*/
   return TRUE;
}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message) 
	{
		case WM_DESTROY:
			PostQuitMessage(0);
			break;
		case WM_ENDSESSION:
			sprintf(userinipath, "%s\\%s", inipath, SETTINGS);
			if(GetFileAttributes(userinipath) != FILE_ATTRIBUTE_DIRECTORY)
				if(!CreateDirectory(userinipath, NULL)) return -1;

			sprintf(userinipath, "%s\\%s\\%s", inipath, SETTINGS, username);

			if(GetFileAttributes(userinipath) != FILE_ATTRIBUTE_DIRECTORY)
				if(!CreateDirectory(userinipath, NULL)) return -1;

			sprintf(userinipath, "%s\\%s\\%s\\%s", inipath, SETTINGS, username, PBINI);
			CopyFile(inifile, userinipath, FALSE);
			break;

		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}

